/***************************************************************************
                          x2k1invtro.h  -  description
                             -------------------
    begin                : Fri Jul 6 2001
    copyright            : (C) 2001 by dureks
    email                : 
 ***************************************************************************/

#ifndef _X2K1INVTRO_H
#define _X2K1INVTRO_H


#include <math.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <DDS/DDS.h>
#include "SDL_gfxPrimitives.h"
#include "evilstuff.h"


using namespace dds;

#define PARTICLE_BOOST_COUNT 10
#define FEATHER_BOOST_COUNT 50
#define SCROLL_SPEED 32
#define MOUSE_SCROLL_SPEED SCROLL_SPEED/2
#define SCROLL_QUICK 300
#define SCROLL_EVIL 48
#define HIGH 1.f
#define EVIL_TOLERANCE HIGH     // ahhh...
#define MOUSE_SHADOW_SKEW 5

/*#define CUBE_SPAWN_X 40
#define CUBE_KILL_X 600
#define CUBE_SPEED .5f
#define CUBE_SPEED_RAND .5f

#define CUBE_SIZE .8f
#define CUBE_SIZE_RAND .5f
*/

/* ---------------- main class -------------------
*/

class Xenox2001: public Demo {
public:
    Xenox2001();
    ~Xenox2001();

protected:
    void display();
    void update();

    void key_pressed(SDLKey key, SDLMod mod);
    void mouse_motion(int16 x, int16 y, int xrel, int yrel);
    void mouse_button_pressed(char8 button, int16 x, int16 y);
    void mouse_button_is_pressed(char8 button, int16 x, int16 y);
    void mouse_button_released(char8 button, int16 x, int16 y);

    void window_focus_gain(char8 state);
    void window_focus_lost(char8 state);

    void tadetvivilha(BaseSurface *source,BaseSurface *dest,const Area &area);

    EvilMesh* loadtxc(const char name[]);
    EvilArea* loadtxa(const char name[]);
    void draw_the_evil(int cx, int cy, float scale, float angle, Color &line, Color &fill, EvilMesh *mesh, BaseSurface *surface);
    void slide_the_evil();

    void eod();

    // event
    bool mouse_focus;
    bool active_app;

    // data
    Image *background;
    Image *menumask;
    Image *light_buttons;
    Image *info;
    Image *droole;
    Area infoarea;
    //GFXFont *fonten;
    Image *fonten;

    //the duck gang
    Sprite *duck[8];
    Image *uimask;
    EvilDuck *evilduck;
    Uint32 ducks_right;
    Uint32 ducks_left;
    Uint32 duck_hit_right;
    Uint32 duck_hit_left;
    bool kill;
    Emitter *feather;
    Feather *scwong;
    Attractor *fjederha;
    Image *fthr[4];
    Image *blood[4];
    Sample *sfx[3];

    float info_ypos;
    float next_ypos;

    Music *music;
    Surface *surface;
    Surface *buffer;

    // evil stuff
    EvilMesh *evilgear;
    float evilrotation;
    Color gearline, gearfill;
    EvilArea *evilarea,*fontarea;
    Uint32 b_active;
    Uint32 b_active_prev;

    EvilMesh *page;
    EvilMesh *cube;
    //Zoom360 *bpd;

    LinkedList<marchCube> *mcube;

    // mouse cursor+shadow
    Vector2 mousepos;
    bool a_active;
    Image *cursor[4];
    Blitter blit;
    Uint32 put_mouse;
    bool mouse_pressed;

    // mousetrail
    Emitter *trail;
    Attractor *attract;
    Gravity *gravity;
    Image *flare;
};

#endif // x2k1invtro